﻿using System;

namespace ConsoleApp1
{
    // C# 8.0에서 썼던 표현들
    class Program
    {
        static void Main(string[] args)
        {
            var t = (args.Length, nameof(Main));

            object objValue = args.Length;

            {
                if (t is (int number, string text)) { } // test if o1 is an int and o2 is a string
                if (t is (int _, string _)) { } // test if o1 is an int and o2 is a string
            }

            {
                switch (objValue)
                {
                    case int number: break; // test if o1 is an int
                    case System.String text: break; // test if o1 is a string
                }

                switch (objValue)
                {
                    case int _: break; // test if o1 is an int
                    case System.String _: break; // test if o1 is a string
                }
            }

            if (!(objValue is null))
            {
                Console.WriteLine("not null");
            }

            Console.WriteLine(GreaterThan10(10));
            Console.WriteLine(GreaterThan10(11));

            Console.WriteLine(IsLetter('a'));
            Console.WriteLine(IsLetter(' '));

            Console.WriteLine(IsLetterOrSeparator('.'));
            Console.WriteLine(IsLetter('0'));
        }

        public static bool GreaterThan10(int number) =>
            number switch { int n when n > 10 => true, _ => false };

        public static bool IsLetter(char c) =>
            c switch { char _ when c >= 'a' && c <= 'z' || c >= 'A' && c <= 'Z' => true, _ => false };

        // C# 9.0 변수 생략 가능
        // public static bool IsLetter(char c) => 
        //  c switch { char when c >= 'a' && c <= 'z' || c >= 'A' && c <= 'Z' => true, _ => false };

        public static bool IsLetterOrSeparator(char c) =>
            c switch
            {
                char _ when (c >= 'a' && c <= 'z')
                         || (c >= 'A' && c <= 'Z')
                         || c == '.'
                         || c == ',' => true,
                _ => false
            };

        // C# 9.0 변수 생략 가능
        //public static bool IsLetterOrSeparator2(char c) =>
        //    c switch
        //    {
        //        char when (c >= 'a' && c <= 'z')
        //                 || (c >= 'A' && c <= 'Z')
        //                 || c == '.'
        //                 || c == ',' => true,
        //        _ => false
        //    };

        
    }
}
