﻿using System;
using System.Runtime.Remoting.Messaging;

class Program
{
    // C# 9.0에서 더 간결하게 바뀐 표현들
    static void Main(string[] args)
    {
        var t = (args.Length, nameof(Main));

        if (t is (int, string)) { } // test if o1 is an int and o2 is a string

        object objValue = args.Length;

        switch (objValue)
        {
            case int: break; // test if o1 is an int
            case System.String: break; // test if o1 is a string
        }

        if (!(objValue is null))
        {
            Console.WriteLine("not null");
        }

        if (objValue is not null)
        {
            Console.WriteLine("not null");
        }
    }

    public static bool GreaterThan10(int number) =>
            number is >= 10;

    /*
    public static bool GreaterThan(int number, int target) =>
            number is >= target; // CS0150 A constant value is expected
    */

    public static bool GreaterThan(int number, int target) =>
            number switch { int value when value >= target => true,
            _ => false };

    public static bool IsLetter(char c) =>
        c is >= 'a' and <= 'z' or >= 'A' and <= 'Z';

    public static bool IsLetterOrSeparator(char c) =>
        c is (>= 'a' and <= 'z') or (>= 'A' and <= 'Z') or '.' or ',';


    public static bool IsLetterOrSeparator2(char c) =>
    c switch
    {
        char when (c >= 'a' && c <= 'z')
                 || (c >= 'A' && c <= 'Z')
                 || c == '.'
                 || c == ',' => true,
        _ => false
    };
}

